/*
ToDo :
Wegbefehle  an Unterarm, Oberarm 
Farben kalibrieren mit min/max Werten für RGB 

*/
import controlP5.*;
import processing.serial.*;
import hypermedia.video.*;
import java.awt.*;


OpenCV opencv;

int i = 0 ;
int w = 320;
int h = 240;
int threshold = 110;

Blob[] blobs;
Point centroid ;
PImage original;

color  c ;

float rota ; 
float gruena ;
float blaua ; 


boolean  blobblau;
int blobblaunr ;




PFont font;

Serial myPort;    // The serial port:

int serialBegin = 255;

ControlP5 controlP5;
controlP5.Label label;
//int myColorBackground = color(0,0,0);

ControlWindow controlWindow;
ControlWindow gotowindow;


int servo1 = 87;
int servo2 = 87;
int Schulter = 3; 
int Unterarm = 81;

public int x ;
public int y ;

// Koordinaten sind minus x mm =  plus y pixel
// und              plus  y mm =  plus x pixel

 float Mx ;  // Massstabx = pixel/mm  Distanz Pkt 1 nach Pkt 4
 float My ;
 
int [] punktxpix = new int[5] ; // Koordianate x in Pixel
int [] punktypix = new int[5] ;// Koordianate y in Pixel

int [] punktxmm = new int[5] ; // Koordianate x in mm
int [] punktymm = new int[5] ;// Koordianate y in mm

void setup() {
   size(600,600);   
   
  punktxpix[1] = 75 ;//obere linke Ecke 
  punktypix[1] = 75  ; 
  punktxpix[2] = 220 ;//    obere rechte Ecke 
  punktypix[2] = 75 ;//
  punktxpix[3] = 220 ;//    untere rechte Ecke 
  punktypix[3] = 190 ;//
  punktxpix[4] = 75 ;//  
  punktypix[4] = 190 ;//

  punktxmm[1] =  40;//obere linke Ecke; minus weggelassen
  punktymm[1] =  110 ; 
  punktxmm[2] = 40;//    obere rechte Ecke 
  punktymm[2] = 225;//
  punktxmm[3] = 135;//    untere rechte Ecke 
  punktymm[3] = 225 ;//
  punktxmm[4] = 135;//  
  punktymm[4] = 110;//
   
   
     
   
    opencv = new OpenCV( this );
    opencv.capture(w,h);
    
  myPort = new Serial(this, Serial.list()[2], 115200);

 
  controlP5 = new ControlP5(this);

 // addSlider(theName, theMin, theMax, theDefaultValue, theX, theY, theW, theH);
  Slider s = controlP5.addSlider("Schulter"    ,0,180,Schulter,50,400,40,100);
         s = controlP5.addSlider("Unterarm"    ,0,180,Unterarm,150,400,40,100);
         s = controlP5.addSlider("threshold" ,0,180,threshold,50,270,40,100);

   controlP5.addButton("Teil_greifen",0,20,530,80,30);
   controlP5.addButton("Eingabe_xy_mm",0,120,530,80,30);
   controlP5.addButton("gehe_nach_A",0,250,530,80,30);
  
  
// Greifer_hoch();
//  Greifer_auf();   
   
 goto_xy_mm(125,270); // Fläche A  
   
}// Setup




void draw() {
   
   background(56);
   blobblau=false;
   blobblaunr = 0; 

   opencv.read(); // image aus webcam lesen
   original= opencv.image();
   //opencv.flip( OpenCV.FLIP_HORIZONTAL );
   
   //  opencv.loadImage( "2euro oben links.jpg", w, h ); //  test
  
   image( opencv.image(),0,0 );	            // RGB image
 
   // ROI(x, y, width, height
   opencv.ROI(punktxpix[1],punktypix[1],(punktxpix[2]-punktxpix[1]),(punktypix[4]-punktypix[1]) );
 
 //  image( opencv.image(OpenCV.GRAY),20+w,10) ;   // GRAY image
 //  image( opencv.image(OpenCV.MEMORY), 10,20+h); // image in memory

   opencv.absDiff();
   opencv.threshold(threshold);
 //  image ( opencv.image(OpenCV.GRAY), 20+w,20+h ); //absolute difference image

    // working with blobs
    blobs = opencv.blobs( 100, w*h/3, 20, true );

    noFill();

//    pushMatrix(); 
//    translate(10,10);
   
  for( int i=0; i<blobs.length; i++ )   
    {

         // Mittelpunkt des Blobs 
        centroid = blobs[i].centroid;
        
        stroke(0,0,255);
        line( centroid.x-5, centroid.y, centroid.x+5, centroid.y );
        line( centroid.x, centroid.y-5, centroid.x, centroid.y+5 );
         
        Point[] points = blobs[i].points;
 
       // Umriss des Blobs zeichnen 
       // fill(255,0,255,64);
       noFill();
        stroke(255,0,255);
        if ( points.length>0 ) {
            beginShape();
            for( int j=0; j<points.length; j++ ) {
                vertex( points[j].x, points[j].y );
            }
            endShape(CLOSE);
        } // abfrage ob es points gibt 

 } // for i bis soundsoviel Blobs
 
 
// Informationen zu ersten 3 Blobs anzeigen

  int j =blobs.length;
  if ( blobs.length > 2 ){
    j=3;}
    
  noStroke();
 
  createFont("Times",30);

  for( int i=0; i<j; i++ )   
   {
      centroid = blobs[i].centroid;     // Mittelpkt.
  
  // ich habe eine  Frage: aus welchem image holt sich get die Farbe ?   
 // aus original oder .Gray  
 // Antwort : aus der cursor-Position ! also cntroid +rand
     
      c = get( centroid.x+1,centroid.y+1); // Welche Farbe hat der Blob
      // 9 da mit 10 genau das Fadenkreuz blau genommen wird
      rota = red(c); 
      gruena = green(c);
      blaua = blue(c); 

      fill(255,255,255);
      text(" Blob "+i,340,10+(i*100));
      text(" Farbe des Blobs =",370,40+(i*100) );    
      text(" Mittelpunkt des Blobs  x="+ centroid.x+" y ="+centroid.y,370,70+(i*100));
      text(" R/G/B Anteile "+rota+"/"+gruena+"/"+blaua,370,85+(i*100)); 
      fill(c);
      rect(520,10+(i*100),40,40);
 
 //     println (" rotanteil  ="+ rota);
 //    println (" gruenanteil="+ gruena);
 //    println (" blauanteil ="+ blaua);
     
   
     if ( (rota<100) && ( gruena <100) && (blaua > 50) )// blob ist bläulich
     {
       blobblau= true;
       blobblaunr = i;
      }     
 
      
   }
  
 
//    popMatrix(); // ?
    
 myPort.write(253);
//delay(2);   
myPort.write(Schulter);

 controlP5.controller("Schulter").setValue(Schulter);
//delay(2);   
myPort.write(252);
myPort.write(Unterarm);    
controlP5.controller("Unterarm").setValue(Unterarm);


/*
 if(mousePressed) {

   x=-round((mouseY-75)/Mx)-35 ;// Mx= ypix/-xmm
   y=round((mouseX-75)/My)+105; //105mm von Null y entfernt Beobachtungsfenster 75 pixel vom Bildrand
   
    
 goto_xy_mm(x,y); 
   
 }
*/

// println ("x ="+x);
// println ("y ="+y);


 
} // End draw


public void Greifer_hoch() {
  myPort.write(254);
   myPort.write(0);
   println("Greifer hoch ");
}
public void Greifer_runter() {
  myPort.write(254);
  myPort.write(180);
  println("Greifer runter");
}

public void Greifer_auf() {
  myPort.write(255);
   myPort.write(0);
  println("Greifer auf");
}
public void Greifer_zu() {
  myPort.write(255);
  myPort.write(180);
  println("Greifer zu");
}

public void yminus() {
  if  (Unterarm > 2 ) {
    Unterarm=Unterarm-1;
    myPort.write(252);
    myPort.write(Unterarm);
  }  
}

public void yplus() {
  if  (Unterarm < 170 ) {
    Unterarm=Unterarm+1;
    myPort.write(252);
    myPort.write(Unterarm);
  }   
}

public void xminus() {
  if  (Schulter > 2 ) {
    Schulter=Schulter-1;
    myPort.write(253);
    myPort.write(Schulter);
//   println("xminus");
  }
}

public void xplus() {
   if  (Schulter < 80 ) {
    Schulter=Schulter+1;
    myPort.write(253);
    
    myPort.write(Schulter);
//   println("xplus");
  }
 
}

public void kalibrieren() {
  controlWindow = controlP5.addControlWindow("controlP5window",100,100,400,200);
  controlWindow.hideCoordinates();
  Textfield field = controlP5.addTextfield("Farbe",70,130,100,20);
  field.setWindow(controlWindow);  
  controlWindow.setTitle("kalibrieren");  
}


public void  Teil_greifen() {

   goto_xy_pix(blobs[0].centroid.x,blobs[0].centroid.y); // Koordinaten des Blobs in Pixel
  
  
 //  delay(500);
 //      myPort.write(200);  // Greifen  Befehle in Arduino
 
 
}

public void Eingabe_xy_mm(){

  controlP5.Button bu; 
  
   gotowindow = controlP5.addControlWindow("gotowindow",700,700,200,200);
   gotowindow.hideCoordinates();
  Textfield tx =controlP5.addTextfield("xstring",20,20,100,14);
  tx.setAutoClear(false);
  Textfield ty = controlP5.addTextfield("ystring",20,60,100,14);
  ty.setAutoClear(false);
  bu= controlP5.addButton("ausfuehren",0,20,100,80,30);
   bu.setWindow(gotowindow);  
   tx.setWindow(gotowindow);  
   ty.setWindow(gotowindow);  
   controlWindow.setTitle("goto xy");  
}  


void ausfuehren() { // Button aus Fenster Eingabe_xy_mm(
  goto_xy_mm(x,y);
 }



void xstring(String theValue) {
  x=int(theValue);
  text(" x = "+x,10,10);  
 }
void ystring(String theValue) {
  y=int(theValue);
 }

public void goto_xy_pix(int xpix, int ypix){
  Mx= (punktypix[4]-punktypix[1]);  
  Mx= Mx/(punktxmm[4]-punktxmm[1]);  // Massstabx = pixel/mm  Distanz Pkt 1 nach Pkt 4
  My= (punktxpix[2]-punktxpix[1]) ;
  My= My/(punktymm[2]-punktymm[1]) ;// Distanz Pkt 1 nach Pkt 2
 
  x=-round((ypix-75)/Mx)-30 ;// Mx= ypix/-xmm
  y=round((xpix-75)/My)+152; //105mm von Null y entfernt Beobachtungsfenster 75 pixel vom Bildrand
 
  goto_xy_mm(x,y); 
  
}

void gehe_nach_A() {
   goto_xy_mm(125,270);
 }


public void goto_xy_mm(int x, int y){
  // mit inverse Kinematic
  // http://www.societyofrobots.com/robot_arm_tutorial.shtml#inverse_kinematics
  int L1= 190 ;// länge Oberarm 190mm
  int L2= 170; // länge Unterarm 160mm
  float c2 = (sq(x)+sq(y)-sq(L1)-sq(L2) ) / (2* L1 * L2);
  float s2 = sqrt(1-sq(c2));
  // Schulter
 float psi=  acos(  (sq(x)+sq(y)-sq(L1)-sq(L2) ) / (2* L1 * L2)  )   *180/PI;
 //Unterarm
 float theta = asin( (y*(L1+L2*c2)-x*L2*s2)/( sq(x)+sq(y)) ) *180/PI;
 
 Unterarm=round(180-psi-38);
 Schulter=+round(theta-26); 
 
}



void keyPressed() {
  
 
  if (key == CODED) {
    
     
    if (keyCode == LEFT) {
      xminus();
     } 
     if (keyCode == RIGHT) {
      xplus();
    } 
 
    if (keyCode == 33) {// Taste Bild rauf
    Greifer_hoch();
    }  
    if (keyCode == 34) {  // Taste Bild runter
    Greifer_runter();
    } 
     if (keyCode == 35) { // Taste Ende
     Greifer_auf(); 
     } 
    if (keyCode == 36) { // Taste Pos1
    Greifer_zu(); 
    } 
    if (keyCode == UP) {
    yplus();
    }
    
   if (keyCode == DOWN) {
    yminus();
    } 
    
  } 
    if (key == 'g') {
      println("greifen");
      myPort.write(200);  // Greifen Befehle in Arduino
    } 
   if ( key==' ' ) opencv.remember(); // initialisieren
  
    if (key == 'k') { 
      println("Farbe kalibrieren");
      kalibrieren();
    }  
    
     
}
